---
title: Range.setEnd()
slug: Web/API/Range/setEnd
tags:
  - API
  - DOM
  - DOM API
  - End
  - Method
  - Range
  - Reference
  - setEnd
---
<div>{{ApiRef("DOM")}}</div>

<p>The <strong><code>Range.setEnd()</code></strong> method sets the end position of a {{ domxref("Range") }} to be located at the given offset into the specified node x.Setting the end point above (higher in the document) than the start point will result in a collapsed range with the start and end points both set to the specified end position.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>range</em>.setEnd(<em>endNode</em>, <em>endOffset</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>endNode</code></dt>
 <dd>The {{ domxref("Node") }} inside which the {{ domxref("Range") }} should end.</dd>
 <dt><code>endOffset</code></dt>
 <dd>An integer greater than or equal to zero representing the offset for the end of the <code>Range</code> from the start of <code>endNode</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Exceptions are thrown as {{domxref("DOMException")}} objects of the following types:</p>

<dl>
 <dt><code>InvalidNodeTypeError</code></dt>
 <dd>The node specified by <code>endNode</code> is a doctype node; range endpoints cannot be located inside a doctype node.</dd>
 <dt><code>IndexSizeError</code></dt>
 <dd>The value specified by <code>endOffset</code> is either greater than or equal to the length of the node or is less than zero.</dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<p>If the <code>endNode</code> is a {{domxref("Node")}} of type {{domxref("Text")}}, {{domxref("Comment")}}, or {{domxref("CDataSection")}}, then <code>endOffset</code> is the number of characters from the start of <code>endNode</code>. For other {{domxref("Node")}} types, <code>endOffset</code> is the number of child nodes between the start of the <code>endNode</code>.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">const range = document.createRange();
const endNode = document.getElementsByTagName('p').item(3);
const endOffset = endNode.childNodes.length;
range.setEnd(endNode, endOffset);
</pre>

<div class="notecard note">
<p><code>setEnd()</code> is commonly used in conjunction with {{domxref("Range.setStart", "setStart()")}} to fully configure a range.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-range-setend', 'Range.setEnd()')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('DOM2 Traversal_Range', 'ranges.html#Level2-Range-method-setEnd', 'Range.setEnd()')}}</td>
   <td>{{Spec2('DOM2 Traversal_Range')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Range.setEnd")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/DOM/DOM_Reference">The DOM interfaces index</a></li>
</ul>
